# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Protected Member Functions | Protected Attributes
dirac::MvData Class Reference

Class for all the motion vector data. More...

`#include <motion.h>`

Inheritance diagram for dirac::MvData:

List of all members.

## Public Member Functions
| MvData (const PicturePredParams &predparams, const int num_refs)
| Constructor.
| ~MvData ()
| Destructor.
PicturePredParams & | GetPicPredParams ()
| Return a reference to the local picture prediction params.
const PicturePredParams & | GetPicPredParams () const
| Return a reference to the local picture prediction params.
MvArray & | Vectors (const int ref_id)
| Get the MVs for a reference.
const MvArray & | Vectors (const int ref_id) const
| Get the MVs for a reference.
MvArray & | GlobalMotionVectors (const int ref_id)
| Get the global MVs for a reference.
const MvArray & | GlobalMotionVectors (const int ref_id) const
| Get the global MVs for a reference.
TwoDArray< ValueType > & | DC (CompSort cs)
| Get the DC values for each component.
const TwoDArray< ValueType > & | DC (CompSort cs) const
| Get the DC values for each component.
const OneDArray< TwoDArray < ValueType > * > & | DC () const
| Get a reference to the vector holding component DC values.
TwoDArray< PredMode > & | Mode ()
| Get the block prediction modes.
const TwoDArray< PredMode > & | Mode () const
| Get the block prediction modes.
TwoDArray< int > & | SBSplit ()
| Get the SB split level.
const TwoDArray< int > & | SBSplit () const
| Get the SB split level.
OneDArray< float > & | GlobalMotionParameters (const int ref_id)
| Get the global motion model parameters.
const OneDArray< float > & | GlobalMotionParameters (const int ref_id) const
| Get the global motion model parameters.

## Protected Member Functions
void | InitMvData ()

## Protected Attributes
PicturePredParams | m_predparams
OneDArray< MvArray * > | m_vectors
OneDArray< MvArray * > | m_gm_vectors
TwoDArray< PredMode > | m_modes
OneDArray< TwoDArray < ValueType > * > | m_dc
TwoDArray< int > | m_sb_split
OneDArray< OneDArray< float > * > | m_gm_params

## Detailed Description

Motion vector data: the motion vectors themselves, the blocks and macroblock modes.

## Constructor & Destructor Documentation

dirac::MvData::MvData | ( | const PicturePredParams & | predparams,
|  | const int | num_refs
| ) |  |

Constructor takes:

Parameters:

  predparams | Picture prediction parameters
  num_refs | the number of references being used for the picture

dirac::MvData::~MvData | ( |  | ) |

## Member Function Documentation

TwoDArray<ValueType>& dirac::MvData::DC | ( | CompSort | cs | ) |
| inline

References m_dc.

const TwoDArray<ValueType>& dirac::MvData::DC | ( | CompSort | cs | ) | const
| inline

References m_dc.

const OneDArray< TwoDArray<ValueType>* >& dirac::MvData::DC | ( |  | ) | const
| inline

References m_dc.

PicturePredParams& dirac::MvData::GetPicPredParams | ( |  | ) |
| inline

References m_predparams.

const PicturePredParams& dirac::MvData::GetPicPredParams | ( |  | ) | const
| inline

References m_predparams.

OneDArray<float>& dirac::MvData::GlobalMotionParameters | ( | const int | ref_id | ) |
| inline

References m_gm_params.

const OneDArray<float>& dirac::MvData::GlobalMotionParameters | ( | const int | ref_id | ) | const
| inline

References m_gm_params.

MvArray& dirac::MvData::GlobalMotionVectors | ( | const int | ref_id | ) |
| inline

References m_gm_vectors.

const MvArray& dirac::MvData::GlobalMotionVectors | ( | const int | ref_id | ) | const
| inline

References m_gm_vectors.

void dirac::MvData::InitMvData | ( |  | ) |
| protected

TwoDArray<PredMode>& dirac::MvData::Mode | ( |  | ) |
| inline

References m_modes.

const TwoDArray<PredMode>& dirac::MvData::Mode | ( |  | ) | const
| inline

References m_modes.

TwoDArray<int>& dirac::MvData::SBSplit | ( |  | ) |
| inline

References m_sb_split.

const TwoDArray<int>& dirac::MvData::SBSplit | ( |  | ) | const
| inline

References m_sb_split.

MvArray& dirac::MvData::Vectors | ( | const int | ref_id | ) |
| inline

References m_vectors.

const MvArray& dirac::MvData::Vectors | ( | const int | ref_id | ) | const
| inline

References m_vectors.

## Member Data Documentation

OneDArray< TwoDArray<ValueType>* > dirac::MvData::m_dc
| protected

Referenced by DC().

OneDArray< OneDArray<float>* > dirac::MvData::m_gm_params
| protected

Referenced by GlobalMotionParameters().

OneDArray<MvArray*> dirac::MvData::m_gm_vectors
| protected

Referenced by GlobalMotionVectors().

TwoDArray<PredMode> dirac::MvData::m_modes
| protected

Referenced by Mode().

PicturePredParams dirac::MvData::m_predparams
| protected

Referenced by GetPicPredParams().

TwoDArray<int> dirac::MvData::m_sb_split
| protected

Referenced by SBSplit().

OneDArray<MvArray*> dirac::MvData::m_vectors
| protected

Referenced by Vectors().

The documentation for this class was generated from the following file:

- motion.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.